import { Frequency } from '@modules/ad/core/domain/ad.types';
import {
  registerDecorator,
  ValidationOptions,
  ValidationArguments,
} from 'class-validator';

export function HasDay(
  property: string,
  validationOptions?: ValidationOptions,
) {
  return function (object: object, propertyName: string) {
    registerDecorator({
      name: 'hasDay',
      target: object.constructor,
      propertyName: propertyName,
      constraints: [property],
      options: validationOptions,
      validator: {
        validate(value: any, args: ValidationArguments) {
          const [relatedPropertyName] = args.constraints;
          const relatedValue = (args.object as any)[relatedPropertyName];
          return (
            value == Frequency.PUNCTUAL ||
            (Array.isArray(relatedValue) &&
              relatedValue.some((scheduleItem) =>
                scheduleItem.hasOwnProperty('day'),
              ))
          );
        },
      },
    });
  };
}
